/* 
///Miicrocontroller PIC18F4550  //////////////////////////////////////////////////////
///Code By; Oyetoke Oluwole Oyeniyi                                                ///
///Note That atleast 10ms is needed as delays between I2c init, starts and stops   ///
///(absent in this, for proper simulation)                                         ///
///Proteus Simulation Circuit Attached                                             ///
///mail; oluwoleoyetoke@yahoo.com                                                  ///
///Date; 22nd June 2013/////////////////////////////////////////////////////////////// */

//LCD Connection
sbit LCD_RS at RD2_bit;
sbit LCD_EN at RD3_bit;
sbit LCD_D7 at RD7_bit;
sbit LCD_D6 at RD6_bit;
sbit LCD_D5 at RD5_bit;
sbit LCD_D4 at RD4_bit;
sbit LCD_RS_Direction at TRISD2_bit;
sbit LCD_EN_Direction at TRISD3_bit;
sbit LCD_D7_Direction at TRISD7_bit;
sbit LCD_D6_Direction at TRISD6_bit;
sbit LCD_D5_Direction at TRISD5_bit;
sbit LCD_D4_Direction at TRISD4_bit;

void main()
{
//Declarations
char tnum0[5], tnum1[5], tnum2[5], tnum3[5], tnum4[5], tnum5[5], tnum6[5], tnum7[5]; //storage buffer for the IntToStr
int seconds, minutes, hours, dayoftheweek, dateofthemonth, month, year;
int *secondss, *minutess, *hourss, *dayoftheweekk, *dateofthemonthh, *monthh, *yearr; //pointers to the ints above in line 18


//Assigning all the pointers
*secondss= seconds ;
*minutess= minutes ;
*hourss= hours;
*dayoftheweekk=  dayoftheweek;
*dateofthemonthh= dateofthemonth;
*monthh=     month ;
*yearr=   year;


ADCON0 = 0;
ADCON1 = 0xFF;
TRISB = 0; // Configure PORTB as output
PORTB = 0;
PORTD = 0xFF;
Lcd_Init();
Lcd_Cmd(_LCD_CURSOR_OFF);
I2C1_Init(100000); // initialize I2C communication
Lcd_Out(1,5, "Init Calendar");
Delay_ms(100);

 //To start the count from 0 0 0 0 sat 1st January, 2000.
  /* I2C1_Start();
    seconds =(seconds & 0x7F);
    hours =(hours & 0x3F);
    I2C1_Wr(0xD0);               // I2C write address
    I2C1_Wr(0x00);              // Start at REG 0 - Seconds
    I2C1_Wr(Dec2Bcd(0));       // REG 0
    I2C1_Wr(Dec2Bcd(0));       // REG 1
    I2C1_Wr(Dec2Bcd(0));        // REG 2
    I2C1_Wr(Dec2Bcd(7));       // REG 3
    I2C1_Wr(Dec2Bcd(1));       // REG 4
    I2C1_Wr(Dec2Bcd(1));       // REG 5
    I2C1_Wr(Dec2Bcd(0));      // REG 6
    I2C1_Wr(0x80);               // REG 7 - Disable squarewave output pin
    I2C1_Stop();
                              */
      
      
 Lcd_Cmd(_LCD_CLEAR);
while(1)
{
//Read Current Status
I2C1_Start(); // issue I2C start signal
I2C1_Wr(0xD0); // send byte via I2C (RTC chip address + Writebit of 0)
I2C1_Wr(0x00); // send byte (address of the specific RTC Register)
I2C1_Repeated_Start(); //This helps you to begin a read activity from that particular register
I2C1_Wr(0xD1); // Address of RTC chip + Read Bit


seconds=Bcd2Dec(I2C1_Rd(1));        //Reads from the seconds register
IntToStr(seconds,tnum0);            //Convert to String for the sake of the LCD
ltrim(tnum0);                        //Trim off the excess left and right spaces
if(seconds==0)
    {
    Lcd_Cmd(_LCD_CLEAR);  // so as not to have 19 on the LCD after 59 and 60 instead  of 01
            }
 
 
minutes=Bcd2Dec(I2C1_Rd(1) & 0x7F);    //Reads from the minutes register considering only the least 7 bits
IntToStr(minutes,tnum1);                //Convert to String for the sake of the LCD
ltrim(tnum1);                           //Trim off the excess left and right spaces


hours=Bcd2Dec(I2C1_Rd(1) & 0x3F);       //Reads from the hours register, hours buffer holds the least 3 bits at this reg location.
IntToStr(hours,tnum2);                      //Convert to String for the sake of the LCD
ltrim(tnum2);                               //Trim off the excess left and right spaces
 
dayoftheweek=Bcd2Dec(I2C1_Rd(1) & 0x7F);   // REG 3     Reads from the dow register
IntToStr(dayoftheweek,tnum3);              //Convert to String for the sake of the LCD
ltrim(tnum3);                            //Trim off the excess left and right spaces
    
dateofthemonth=Bcd2Dec(I2C1_Rd(1) & 0x3F);   // REG 4      Reads from the dom register
IntToStr(dateofthemonth,tnum4);              //Convert to String for the sake of the LCD
ltrim(tnum4);                               //Trim off the excess left and right spaces
    
    
month=Bcd2Dec(I2C1_Rd(1) & 0x1F);   // REG 5 Reads from the month register
IntToStr(month,tnum5);               //Convert to String for the sake of the LCD
ltrim(tnum5);                          //Trim off the excess left and right spaces
    
    
year=Bcd2Dec(I2C1_Rd(0));         // REG 6   Reads from the year register
IntToStr(year,tnum6);              //Convert to String for the sake of the LCD
ltrim(tnum6);                     //Trim off the excess left and right spaces

     
     //Output the Time (hour:Min:Sec)
 Lcd_Out(1,6, tnum2);
 Lcd_Out_Cp(" : " );
 Lcd_Out_Cp(tnum1);
 Lcd_Out_Cp(" : ");
 Lcd_Out_Cp(tnum0);
Lcd_Cmd(_LCD_THIRD_ROW);   //Move to the next row


//Output the Day of the Week
switch (dayoftheweek)
{
case 1:  Lcd_Out_Cp("Sun ");
break;
case 2:  Lcd_Out_Cp("Mon ");
break;
case 3:  Lcd_Out_Cp("Tue ");
break;
case 4:  Lcd_Out_Cp("Wed ");
break;
case 5:  Lcd_Out_Cp("Thu ");
break;
case 6:  Lcd_Out_Cp("Fri ");
break;
case 7:  Lcd_Out_Cp("Sat ");
break;
}

//Tune for appropriate 1st, 2nd, 3rd and 4ths'
if (dateofthemonth==1 || dateofthemonth==21 || dateofthemonth==31)
{
Lcd_Out_Cp(tnum4);
Lcd_Out_Cp("st of ");
}
else if (dateofthemonth==2 || dateofthemonth==22)
{
Lcd_Out_Cp(tnum4);
Lcd_Out_Cp("nd of ");
}
  else if (dateofthemonth==3 || dateofthemonth==23)
{
Lcd_Out_Cp(tnum4);
Lcd_Out_Cp("rd of ");
}
else
{
Lcd_Out_Cp(tnum4);
Lcd_Out_Cp("th of ");
}


  //Output Month of the year
switch (month)
{
case 1:Lcd_Out_Cp("Jan ");
break;
case 2:Lcd_Out_Cp("Feb ");
break;
case 3:Lcd_Out_Cp("Mar ");
break;
case 4:Lcd_Out_Cp("Apr ");
break;
case 5:Lcd_Out_Cp("May ");
break;
case 6:Lcd_Out_Cp("Jun ");
break;
case 7:Lcd_Out_Cp("Jul ");
break;
case 8:Lcd_Out_Cp("Aug ");
break;
case 9:Lcd_Out_Cp("Sept. ");
break;
case 10:Lcd_Out_Cp("Oct ");
break;
case 11:Lcd_Out_Cp("Nov ");
break;
case 12:Lcd_Out_Cp("Dec ");
break;
}


//Output the year of the century, preceeded by 20 e.g [20]13
Lcd_Out_Cp("20");
Lcd_Out_Cp(tnum6);
I2C1_Stop(); // issue I2C stop signal
seconds=(seconds & 0x7F);   // seconds buffer byte holds the lower 7 bits of seconds.


//To continue to point newly updated date to the chars
    I2C1_Start();
    I2C1_Wr(0xD0);
    I2C1_Wr(0x00);                     // Start at REG 3 - Day of week
    I2C1_Repeated_Start();
    I2C1_Wr(0xD1);
    *secondss=I2C1_Rd(1);
    *minutess=Bcd2Dec(I2C1_Rd(1) & 0x7F);
    *hourss=Bcd2Dec(I2C1_Rd(1) & 0x3F);
    *dayoftheweekk=Bcd2Dec(I2C1_Rd(1) & 0x7F);   // REG 3
    *dateofthemonthh=Bcd2Dec(I2C1_Rd(1) & 0x3F);   // REG 4
    *monthh=Bcd2Dec(I2C1_Rd(1) & 0x1F);   // REG 5
    *yearr=Bcd2Dec(I2C1_Rd(0));         // REG 6
    I2C1_Stop();
    

            }

}